#include <bits/stdc++.h>

using namespace std;

vector <long long> a[200104];

long long i, n, q[200104], v, x, y, m, res[200104], o = 0;

string r = "NO";

int main() {
    cin >> n >> m;
    for (i = 1; i <= m; i ++) {
        cin >> x >> y;
    }
    cout << "NO";
    return 0;
}
